kdecore Library: KProcess Class Reference (kdecore Library)

| # kdecore Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KProcess Class Reference

Child process invocation, monitoring and control. More...

`#include <kprocess.h>`

Inheritance diagram for KProcess:

[legend]
Collaboration diagram for KProcess:

[legend]
List of all members.

## Public Types
enum | Communication { NoCommunication = 0, Stdin = 1, Stdout = 2, Stderr = 4, AllOutput = 6, All = 7, NoRead }
enum | RunMode { DontCare, NotifyOnExit, Block, OwnGroup }
enum | { PrioLowest = 20, PrioLow = 10, PrioLower = 5, PrioNormal = 0, PrioHigher = -5, PrioHigh = -10, PrioHighest = -19 }
## Signals
void | processExited (KProcess *proc)
void | receivedStdout (KProcess *proc, char *buffer, int buflen)
void | receivedStdout (int fd, int &len)
void | receivedStderr (KProcess *proc, char *buffer, int buflen)
void | wroteStdin (KProcess *proc)
## Public Member Functions
| KProcess (QObject *parent, const char *name=0)
| KProcess ()
virtual | ~KProcess ()
bool | setExecutable (const QString &proc) KDE_DEPRECATED
KProcess & | operator<< (const QString &arg)
KProcess & | operator<< (const char *arg)
KProcess & | operator<< (const QCString &arg)
KProcess & | operator<< (const QStringList &args)
void | clearArguments ()
virtual bool | start (RunMode runmode=NotifyOnExit, Communication comm=NoCommunication)
virtual bool | kill (int signo=SIGTERM)
bool | isRunning () const
pid_t | pid () const
KDE_DEPRECATED pid_t | getPid () const
void | suspend ()
void | resume ()
bool | wait (int timeout=-1)
bool | normalExit () const
bool | signalled () const
bool | coreDumped () const
int | exitStatus () const
int | exitSignal () const
bool | writeStdin (const char *buffer, int buflen)
bool | closeStdin ()
bool | closeStdout ()
bool | closeStderr ()
bool | closePty ()
void | closeAll ()
const QValueList< QCString > & | args ()
void | setRunPrivileged (bool keepPrivileges)
bool | runPrivileged () const
void | setEnvironment (const QString &name, const QString &value)
void | setWorkingDirectory (const QString &dir)
void | setUseShell (bool useShell, const char *shell=0)
void | detach ()
bool | setPriority (int prio)
## Static Public Member Functions
static QString | quote (const QString &arg)
## Protected Slots
void | slotChildOutput (int fdno)
void | slotChildError (int fdno)
void | slotSendData (int dummy)
## Protected Member Functions
void | setupEnvironment ()
virtual int | setupCommunication (Communication comm)
virtual int | commSetupDoneP ()
virtual int | commSetupDoneC ()
virtual void | processHasExited (int state)
virtual void | commClose ()
void | setBinaryExecutable (const char *filename)
int | childOutput (int fdno)
int | childError (int fdno)
virtual void | virtual_hook (int id, void *data)
## Protected Attributes
QValueList< QCString > | arguments
RunMode | run_mode
bool | runs
pid_t | pid_
int | status
bool | keepPrivs
int | out [2]
int | in [2]
int | err [2]
QSocketNotifier * | innot
QSocketNotifier * | outnot
QSocketNotifier * | errnot
Communication | communication
const char * | input_data
int | input_sent
int | input_total
## Friends
class | KProcessController

## Detailed Description

Child process invocation, monitoring and control.

General usage and features:

This class allows a KDE application to start child processes without having to worry about UN*X signal handling issues and zombie process reaping.

See also:
  KProcIO

Basically, this class distinguishes three different ways of running child processes:

- DontCare -- The child process is invoked and both the child process and the parent process continue concurrently.

The process is started in an own session (see setsid(2)).

- NotifyOnExit -- The child process is invoked and both the child and the parent process run concurrently.

When the child process exits, the KProcess instance corresponding to it emits the Qt signal processExited(). Since this signal is not emitted from within a UN*X signal handler, arbitrary function calls can be made.

Be aware: When the KProcess object gets destructed, the child process will be killed if it is still running! This means in particular, that it usually makes no sense to use a KProcess on the stack with NotifyOnExit.

- OwnGroup -- like NotifyOnExit, but the child process is started in an own process group (and an own session, FWIW). The behavior of kill() changes to killing the whole process group - this makes this mode useful for implementing primitive job management. It can be used to work around broken wrapper scripts that don't propagate signals to the "real" program. However, use this with care, as you disturb the shell's job management if your program is started from the command line.

- Block -- The child process starts and the parent process is suspended until the child process exits. (Really not recommended for programs with a GUI.) In this mode the parent can read the child's output, but can't send it any input.

KProcess also provides several functions for determining the exit status and the pid of the child process it represents.

Furthermore it is possible to supply command-line arguments to the process in a clean fashion (no null-terminated stringlists and such...)

A small usage example:

       KProcess *proc = new KProcess;

       *proc << "my_executable";
       *proc << "These" << "are" << "the" << "command" << "line" << "args";
       QApplication::connect(proc, SIGNAL(processExited(KProcess *)),
                             pointer_to_my_object, SLOT(my_objects_slot(KProcess *)));
       proc->start();

This will start "my_executable" with the commandline arguments "These"...

When the child process exits, the slot will be invoked.

Communication with the child process:

KProcess supports communication with the child process through stdin/stdout/stderr.

The following functions are provided for getting data from the child process or sending data to the child's stdin (For more information, have a look at the documentation of each function):

- writeStdin() -- Transmit data to the child process' stdin. When all data was sent, the signal wroteStdin() is emitted.

- When data arrives at stdout or stderr, the signal receivedStdout() resp. receivedStderr() is emitted.

- You can shut down individual communication channels with closeStdin(), closeStdout(), and closeStderr(), resp.

Author:
  Christian Czezatke e9025461@student.tuwien.ac.at

Definition at line 124 of file kprocess.h.

## Member Enumeration Documentation

enum KProcess::Communication

| Modes in which the communication channel can be opened. If communication for more than one channel is required, the values have to be or'ed together, for example to get communication with stdout as well as with stdin, you would specify `Stdin` | `Stdout` If `NoRead` is specified in conjunction with `Stdout`, no data is actually read from `Stdout` but only the signal receivedStdout(int fd, int &len) is emitted. Definition at line 142 of file kprocess.h.

enum KProcess::RunMode

  | Run-modes for a child process. Enumeration values:
  DontCare | The application does not receive notifications from the subprocess when it is finished or aborted.
  NotifyOnExit | The application is notified when the subprocess dies.
  Block | The application is suspended until the started process is finished.
  OwnGroup | Same as NotifyOnExit, but the process is run in an own session, just like with DontCare.
Definition at line 152 of file kprocess.h.

anonymous enum

| More or less intuitive constants for use with setPriority(). Definition at line 552 of file kprocess.h.

## Constructor & Destructor Documentation

KProcess::KProcess | ( | QObject * | parent,
|  | const char * | name = `0`
| ) |

| Constructor Since: 3.2. Definition at line 120 of file kprocess.cpp. References KProcessController::addKProcess(), err, in, out, and KProcessController::ref().

KProcess::KProcess | ( |  | ) |

| Constructor. Definition at line 145 of file kprocess.cpp. References KProcessController::addKProcess(), err, in, out, and KProcessController::ref().

KProcess::~KProcess | ( |  | ) | `[virtual]`

| Destructor:. If the process is running when the destructor for this class is called, the child process is killed with a SIGKILL, but only if the run mode is not of type `DontCare`. Processes started as `DontCare` keep running anyway. Definition at line 225 of file kprocess.cpp. References KProcessController::deref(), detach(), DontCare, kill(), KProcessController::removeKProcess(), and run_mode.

## Member Function Documentation

bool KProcess::setExecutable | ( | const QString & | proc | ) |

| Deprecated: Use operator<< instead. Sets the executable to be started with this KProcess object. Returns false if the process is currently running (in that case the executable remains unchanged). See also: operator<< Definition at line 255 of file kprocess.cpp. References arguments, QValueList::begin(), QValueList::isEmpty(), QValueList::prepend(), QValueList::remove(), and runs.

KProcess & KProcess::operator<< | ( | const QString & | arg | ) |

| Sets the executable and the command line argument list for this process. For example, doing an "ls -l /usr/local/bin" can be achieved by:
      KProcess p;
      ...
      p << "ls" << "-l" << "/usr/local/bin"
  Parameters:
  | arg | the argument to add
Returns: a reference to this KProcess Definition at line 287 of file kprocess.cpp. References QValueList::append(), and arguments. Referenced by operator<<().

KProcess & KProcess::operator<< | ( | const char * | arg | ) |

| Similar to previous method, takes a char *, supposed to be in locale 8 bit already. Definition at line 281 of file kprocess.cpp. References QValueList::append(), and arguments.

KProcess & KProcess::operator<< | ( | const QCString & | arg | ) |

  | Similar to previous method, takes a QCString, supposed to be in locale 8 bit already. Parameters:
  | arg | the argument to add
Returns: a reference to this KProcess Definition at line 276 of file kprocess.cpp. References operator<<().

KProcess & KProcess::operator<< | ( | const QStringList & | args | ) |

  | Sets the executable and the command line argument list for this process, in a single method call, or add a list of arguments. Parameters:
  | args | the arguments to add
Returns: a reference to this KProcess Definition at line 268 of file kprocess.cpp. References QValueList::append(), args(), arguments, QValueList::begin(), and QValueList::end().

void KProcess::clearArguments | ( |  | ) |

| Clear a command line argument list that has been set by using operator<<. Definition at line 293 of file kprocess.cpp. References arguments, and QValueList::clear(). Referenced by KProcIO::resetAll().

bool KProcess::start | ( | RunMode | runmode = `NotifyOnExit`,
|  | Communication | comm = `NoCommunication`
| ) | `[virtual]`

  | Starts the process. For a detailed description of the various run modes and communication semantics, have a look at the general description of the KProcess class. Note that if you use setUsePty( Stdout | Stderr, <bool> ), you cannot use Stdout | Stderr here - instead, use Stdout only to receive the mixed output. The following problems could cause this function to return false: The process is already running. The command line argument list is empty. The the `comm` parameter is incompatible with the selected pty usage. The starting of the process failed (could not fork). The executable was not found. Parameters:
  | runmode | The Run-mode for the process.
  | comm | Specifies which communication links should be established to the child process (stdin/stdout/stderr). By default, no communication takes place and the respective communication signals will never get emitted.
Returns: true on success, false on error (see above for error conditions) Reimplemented in KShellProcess. Definition at line 298 of file kprocess.cpp. References arguments, Block, commClose(), commSetupDoneC(), commSetupDoneP(), QValueList::count(), DontCare, endl(), QApplication::flushX(), input_data, OwnGroup, pid_, processExited(), KProcessController::rescheduleCheck(), run_mode, runPrivileged(), runs, setupCommunication(), setupEnvironment(), status, and KProcessController::unscheduleCheck(). Referenced by KConfigBackEnd::checkConfigFilesWritable(), KProcIO::start(), and KShellProcess::start().

bool KProcess::kill | ( | int | signo = `SIGTERM` | ) | `[virtual]`

  | Stop the process (by sending it a signal). Parameters:
  | signo | The signal to send. The default is SIGTERM.
Returns: true if the signal was delivered successfully. Definition at line 492 of file kprocess.cpp. References OwnGroup, pid_, run_mode, and runs. Referenced by KProcIO::resetAll(), and ~KProcess().

bool KProcess::isRunning | ( |  | ) | const

| Checks whether the process is running. Returns: true if the process is (still) considered to be running Definition at line 503 of file kprocess.cpp. References runs. Referenced by KProcIO::resetAll().

pid_t KProcess::pid | ( |  | ) | const

| Returns the process id of the process. If it is called after the process has exited, it returns the process id of the last child process that was created by this instance of KProcess. Calling it before any child process has been started by this KProcess instance causes pid() to return 0. Returns: the pid of the process or 0 if no process has been started yet. Definition at line 510 of file kprocess.cpp. References pid_.

KDE_DEPRECATED pid_t KProcess::getPid | ( |  | ) | const`[inline]`

| Deprecated: Use pid() instead. Definition at line 306 of file kprocess.h.

void KProcess::suspend | ( |  | ) |

| Suspend processing of data from stdout of the child process. Definition at line 647 of file kprocess.cpp. References outnot, and QSocketNotifier::setEnabled(). Referenced by commSetupDoneP().

void KProcess::resume | ( |  | ) |

| Resume processing of data from stdout of the child process. Definition at line 653 of file kprocess.cpp. References outnot, and QSocketNotifier::setEnabled().

bool KProcess::wait | ( | int | timeout = `-1` | ) |

  | Suspend execution of the current thread until the child process dies or the timeout hits. This function is not recommended for programs with a GUI. Parameters:
  | timeout | timeout in seconds. -1 means wait indefinitely.
Returns: true if the process exited, false if the timeout hit. Since: 3.2 Definition at line 527 of file kprocess.cpp. References KProcessController::notifierFd(), pid_, processHasExited(), KProcessController::rescheduleCheck(), runs, status, and KProcessController::unscheduleCheck().

bool KProcess::normalExit | ( |  | ) | const

| Checks whether the process exited cleanly. Returns: true if the process has already finished and has exited "voluntarily", ie: it has not been killed by a signal. Definition at line 593 of file kprocess.cpp. References pid_, runs, and status.

bool KProcess::signalled | ( |  | ) | const

| Checks whether the process was killed by a signal. Returns: true if the process has already finished and has not exited "voluntarily", ie: it has been killed by a signal. Since: 3.2 Definition at line 599 of file kprocess.cpp. References pid_, runs, and status. Referenced by coreDumped().

bool KProcess::coreDumped | ( |  | ) | const

| Checks whether a killed process dumped core. Returns: true if signalled() returns true and the process dumped core. Note that on systems that don't define the WCOREDUMP macro, the return value is always false. Since: 3.2 Definition at line 605 of file kprocess.cpp. References signalled(), and status.

int KProcess::exitStatus | ( |  | ) | const

| Returns the exit status of the process. Returns: the exit status of the process. Note that this value is not valid if normalExit() returns false. Definition at line 615 of file kprocess.cpp. References status.

int KProcess::exitSignal | ( |  | ) | const

| Returns the signal the process was killed by. Returns: the signal number that caused the process to exit. Note that this value is not valid if signalled() returns false. Since: 3.2 Definition at line 621 of file kprocess.cpp. References status.

bool KProcess::writeStdin | ( | const char * | buffer,
|  | int | buflen
| ) |

  | Transmit data to the child process' stdin. This function may return false in the following cases: The process is not currently running. This implies that you cannot use this function in Block mode. Communication to stdin has not been requested in the start() call. Transmission of data to the child process by a previous call to writeStdin() is still in progress. Please note that the data is sent to the client asynchronously, so when this function returns, the data might not have been processed by the child process. That means that you must not free `buffer` or call writeStdin() again until either a wroteStdin() signal indicates that the data has been sent or a processExited() signal shows that the child process is no longer alive. If all the data has been sent to the client, the signal wroteStdin() will be emitted. Parameters:
  | buffer | the buffer to write
  | buflen | the length of the buffer
Returns: false if an error has occurred Definition at line 627 of file kprocess.cpp. References communication, innot, input_data, input_sent, input_total, QSocketNotifier::setEnabled(), and slotSendData(). Referenced by KProcIO::fputs(), and KProcIO::writeStdin().

bool KProcess::closeStdin | ( |  | ) |

| Shuts down the Stdin communication link. If no pty is used, this causes "EOF" to be indicated on the child's stdin file descriptor. Returns: false if no Stdin communication link exists (any more). Definition at line 659 of file kprocess.cpp. References communication, in, and innot. Referenced by closeAll(), KProcIO::closeWhenDone(), commClose(), and slotSendData().

bool KProcess::closeStdout | ( |  | ) |

| Shuts down the Stdout communication link. If no pty is used, any further attempts by the child to write to its stdout file descriptor will cause it to receive a SIGPIPE. Returns: false if no Stdout communication link exists (any more). Definition at line 673 of file kprocess.cpp. References communication, out, and outnot. Referenced by closeAll(), commClose(), and slotChildOutput().

bool KProcess::closeStderr | ( |  | ) |

| Shuts down the Stderr communication link. If no pty is used, any further attempts by the child to write to its stderr file descriptor will cause it to receive a SIGPIPE. Returns: false if no Stderr communication link exists (any more). Definition at line 687 of file kprocess.cpp. References communication, err, and errnot. Referenced by closeAll(), commClose(), and slotChildError().

bool KProcess::closePty | ( |  | ) |

| Deletes the optional utmp entry and closes the pty. Make sure to shut down any communication links that are using the pty before calling this function. Returns: false if the pty is not open (any more). Definition at line 701 of file kprocess.cpp. Referenced by closeAll(), and commClose().

void KProcess::closeAll | ( |  | ) |

| Calls the above four close* functions in a row. Definition at line 716 of file kprocess.cpp. References closePty(), closeStderr(), closeStdin(), and closeStdout().

const QValueList<QCString>& KProcess::args | ( |  | ) | `[inline]`

| Lets you see what your arguments are for debugging. Returns: the list of arguments Definition at line 450 of file kprocess.h. Referenced by operator<<().

void KProcess::setRunPrivileged | ( | bool | keepPrivileges | ) |

  | Controls whether the started process should drop any setuid/setgid privileges or whether it should keep them. Note that this function is mostly a dummy, as the KDE libraries currently refuse to run with setuid/setgid privileges. The default is false: drop privileges Parameters:
  | keepPrivileges | true to keep the privileges
Definition at line 198 of file kprocess.cpp. References keepPrivs.

bool KProcess::runPrivileged | ( |  | ) | const

| Returns whether the started process will drop any setuid/setgid privileges or whether it will keep them. Returns: true if the process runs privileged Definition at line 204 of file kprocess.cpp. References keepPrivs. Referenced by start().

void KProcess::setEnvironment | ( | const QString & | name,
|  | const QString & | value
| ) |

  | Adds the variable `name` to the process' environment. This function must be called before starting the process. Parameters:
  | name | the name of the environment variable
  | value | the new value for the environment variable
Definition at line 171 of file kprocess.cpp.

void KProcess::setWorkingDirectory | ( | const QString & | dir | ) |

  | Changes the current working directory (CWD) of the process to be started. This function must be called before starting the process. Parameters:
  | dir | the new directory
Definition at line 177 of file kprocess.cpp.

void KProcess::setUseShell | ( | bool | useShell,
|  | const char * | shell = `0`
| ) |

  | Specify whether to start the command via a shell or directly. The default is to start the command directly. If `useShell` is true `shell` will be used as shell, or if shell is empty, /bin/sh will be used. When using a shell, the caller should make sure that all filenames etc. are properly quoted when passed as argument. See also: quote() Parameters:
  | useShell | true if the command should be started via a shell
  | shell | the path to the shell that will execute the process, or 0 to use /bin/sh. Use getenv("SHELL") to use the user's default shell, but note that doing so is usually a bad idea for shell compatibility reasons.
Since: 3.1 Definition at line 764 of file kprocess.cpp. Referenced by KShellProcess::KShellProcess().

QString KProcess::quote | ( | const QString & | arg | ) | `[static]`

  | This function can be used to quote an argument string such that the shell processes it properly. This is e. g. necessary for user-provided file names which may contain spaces or quotes. It also prevents expansion of wild cards and environment variables. Parameters:
  | arg | the argument to quote
Returns: the quoted argument Since: 3.1 Reimplemented in KShellProcess. Definition at line 808 of file kprocess.cpp. References QString::append(), QString::prepend(), and QString::replace(). Referenced by KShellProcess::quote(), and KTempDir::unlink().

void KProcess::detach | ( |  | ) |

| Detaches KProcess from child process. All communication is closed. No exit notification is emitted any more for the child process. Deleting the KProcess will no longer kill the child process. Note that the current process remains the parent process of the child process. Definition at line 240 of file kprocess.cpp. References KProcessController::addProcess(), commClose(), pid_, and runs. Referenced by ~KProcess().

bool KProcess::setPriority | ( | int | prio | ) |

  | Sets the scheduling priority of the process. Parameters:
  | prio | the new priority in the range -20 (high) to 19 (low).
Returns: false on error; see setpriority(2) for possible reasons. Since: 3.2 Definition at line 210 of file kprocess.cpp. References pid_, and runs.

void KProcess::processExited | ( | KProcess * | proc | ) | `[signal]`

  | Emitted after the process has terminated when the process was run in the `NotifyOnExit` (==default option to start() ) or the Block mode. Parameters:
  | proc | a pointer to the process that has exited
Referenced by processHasExited(), and start().

void KProcess::receivedStdout | ( | KProcess * | proc,
|  | char * | buffer,
|  | int | buflen
| ) | `[signal]`

  | Emitted, when output from the child process has been received on stdout. To actually get this signal, the Stdout communication link has to be turned on in start(). Parameters:
  | proc | a pointer to the process that has received the output
  | buffer | The data received.
  | buflen | The number of bytes that are available.
You should copy the information contained in `buffer` to your private data structures before returning from the slot. Example:
         QString myBuf = QString::fromLatin1(buffer, buflen);
Referenced by childOutput().

void KProcess::receivedStdout | ( | int | fd,
|  | int & | len
| ) | `[signal]`

  | Emitted when output from the child process has been received on stdout. To actually get this signal, the Stdout communication link has to be turned on in start() and the NoRead flag must have been passed. You will need to explicitly call resume() after your call to start() to begin processing data from the child process' stdout. This is to ensure that this signal is not emitted when no one is connected to it, otherwise this signal will not be emitted. The data still has to be read from file descriptor `fd`. Parameters:
  | fd | the file descriptor that provides the data
  | len | the number of bytes that have been read from `fd` must be written here

void KProcess::receivedStderr | ( | KProcess * | proc,
|  | char * | buffer,
|  | int | buflen
| ) | `[signal]`

  | Emitted, when output from the child process has been received on stderr. To actually get this signal, the Stderr communication link has to be turned on in start(). You should copy the information contained in `buffer` to your private data structures before returning from the slot. Parameters:
  | proc | a pointer to the process that has received the data
  | buffer | The data received.
  | buflen | The number of bytes that are available.
Referenced by childError().

void KProcess::wroteStdin | ( | KProcess * | proc | ) | `[signal]`

  | Emitted after all the data that has been specified by a prior call to writeStdin() has actually been written to the child process. Parameters:
  | proc | a pointer to the process
Referenced by KProcIO::resetAll(), slotSendData(), and KProcIO::start().

void KProcess::slotChildOutput | ( | int | fdno | ) | `[protected, slot]`

  | This slot gets activated when data from the child's stdout arrives. It usually calls childOutput(). Parameters:
  | fdno | the file descriptor for the output
Definition at line 730 of file kprocess.cpp. References childOutput(), and closeStdout(). Referenced by commClose(), and commSetupDoneP().

void KProcess::slotChildError | ( | int | fdno | ) | `[protected, slot]`

  | This slot gets activated when data from the child's stderr arrives. It usually calls childError(). Parameters:
  | fdno | the file descriptor for the output
Definition at line 737 of file kprocess.cpp. References childError(), and closeStderr(). Referenced by commClose(), and commSetupDoneP().

void KProcess::slotSendData | ( | int | dummy | ) | `[protected, slot]`

  | Called when another bulk of data can be sent to the child's stdin. If there is no more data to be sent to stdin currently available, this function must disable the QSocketNotifier innot. Parameters:
  | dummy | ignore this argument
Definition at line 744 of file kprocess.cpp. References closeStdin(), endl(), in, innot, input_data, input_sent, input_total, QSocketNotifier::setEnabled(), and wroteStdin(). Referenced by commSetupDoneP(), and writeStdin().

void KProcess::setupEnvironment | ( |  | ) | `[protected]`

| Sets up the environment according to the data passed via setEnvironment(). Definition at line 183 of file kprocess.cpp. References QMap::begin(), QFile::encodeName(), and QMap::end(). Referenced by start().

int KProcess::setupCommunication | ( | Communication | comm | ) | `[protected, virtual]`

| This function is called from start() right before a fork() takes place. According to the `comm` parameter this function has to initialize the in, out and err data members of KProcess. This function should return 1 if setting the needed communication channels was successful. The default implementation is to create UNIX STREAM sockets for the communication, but you could reimplement this function to establish a TCP/IP communication for network communication, for example. Definition at line 873 of file kprocess.cpp. References communication, endl(), err, in, and out. Referenced by start().

int KProcess::commSetupDoneP | ( |  | ) | `[protected, virtual]`

| Called right after a (successful) fork() on the parent side. This function will usually do some communications cleanup, like closing in[0], out[1] and out[1]. Furthermore, it must also create the QSocketNotifiers innot, outnot and errnot and connect their Qt signals to the respective KProcess slots. For a more detailed explanation, it is best to have a look at the default implementation in kprocess.cpp. Definition at line 941 of file kprocess.cpp. References communication, QObject::connect(), err, errnot, in, innot, NotifyOnExit, out, outnot, OwnGroup, run_mode, QSocketNotifier::setEnabled(), slotChildError(), slotChildOutput(), slotSendData(), and suspend(). Referenced by start().

int KProcess::commSetupDoneC | ( |  | ) | `[protected, virtual]`

| Called right after a (successful) fork(), but before an exec() on the child process' side. It usually duplicates the in[0], out[1] and err[1] file handles to the respective standard I/O handles. Definition at line 986 of file kprocess.cpp. References communication, err, in, and out. Referenced by start().

void KProcess::processHasExited | ( | int | state | ) | `[protected, virtual]`

  | Immediately called after a successfully started process in NotifyOnExit mode has exited. This function normally calls commClose() and emits the processExited() signal. Parameters:
  | state | the exit code of the process as returned by waitpid()
Definition at line 820 of file kprocess.cpp. References commClose(), DontCare, processExited(), run_mode, runs, and status. Referenced by wait().

void KProcess::commClose | ( |  | ) | `[protected, virtual]`

| Cleans up the communication links to the child after it has exited. This function should act upon the values of pid() and runs. See the kprocess.cpp source for details. If pid() returns zero, the communication links should be closed only. if pid() returns non-zero and runs is false, all data immediately available from the communication links should be processed before closing them. if pid() returns non-zero and runs is true, the communication links should be monitored for data until the file handle returned by KProcessController::theKProcessController->notifierFd() becomes ready for reading - when it triggers, runs should be reset to false, and the function should be immediately left without closing anything. The previous semantics of this function are forward-compatible, but should be avoided, as they are prone to race conditions and can cause KProcess (and thus the whole program) to lock up under certain circumstances. At the end the function closes the communication links in any case. Additionally if runs is true, the communication links are monitored for data until all of them have returned EOF. Note that if any system function is interrupted (errno == EINTR) the polling loop should be aborted. if runs is false, all data immediately available from the communication links is processed. Definition at line 1032 of file kprocess.cpp. References closePty(), closeStderr(), closeStdin(), closeStdout(), communication, err, KProcessController::notifierFd(), out, pid_, runs, slotChildError(), and slotChildOutput(). Referenced by detach(), processHasExited(), and start().

void KProcess::setBinaryExecutable | ( | const char * | filename | ) | `[protected]`

| Specify the actual executable that should be started (first argument to execve) Normally the the first argument is the executable but you can override that with this function. Definition at line 250 of file kprocess.cpp.

int KProcess::childOutput | ( | int | fdno | ) | `[protected]`

| Called by slotChildOutput() this function copies data arriving from the child process' stdout to the respective buffer and emits the signal receivedStdout(). Definition at line 835 of file kprocess.cpp. References communication, and receivedStdout(). Referenced by slotChildOutput().

int KProcess::childError | ( | int | fdno | ) | `[protected]`

| Called by slotChildError() this function copies data arriving from the child process' stderr to the respective buffer and emits the signal receivedStderr(). Definition at line 858 of file kprocess.cpp. References receivedStderr(). Referenced by slotChildError().

## Friends And Related Function Documentation

friend class KProcessController`[friend]`

| KProcessController is a friend of KProcess because it has to have access to various data members. Definition at line 864 of file kprocess.h.

## Member Data Documentation

QValueList<QCString> KProcess::arguments`[protected]`

| The list of the process' command line arguments. The first entry in this list is the executable itself. Definition at line 675 of file kprocess.h. Referenced by clearArguments(), operator<<(), setExecutable(), and start().

RunMode KProcess::run_mode`[protected]`

| How to run the process (Block, NotifyOnExit, DontCare). You should not modify this data member directly from derived classes. Definition at line 680 of file kprocess.h. Referenced by commSetupDoneP(), kill(), processHasExited(), start(), and ~KProcess().

bool KProcess::runs`[protected]`

| true if the process is currently running. You should not modify this data member directly from derived classes. Please use isRunning() for reading the value of this data member since it will probably be made private in later versions of KProcess. Definition at line 687 of file kprocess.h. Referenced by commClose(), detach(), isRunning(), kill(), normalExit(), processHasExited(), setExecutable(), setPriority(), signalled(), start(), and wait().

pid_t KProcess::pid_`[protected]`

| The PID of the currently running process. You should not modify this data member in derived classes. Please use pid() instead of directly accessing this member since it will probably be made private in later versions of KProcess. Definition at line 696 of file kprocess.h. Referenced by commClose(), detach(), kill(), normalExit(), pid(), setPriority(), signalled(), start(), and wait().

int KProcess::status`[protected]`

| The process' exit status as returned by waitpid(). You should not modify the value of this data member from derived classes. You should rather use exitStatus() than accessing this data member directly since it will probably be made private in further versions of KProcess. Definition at line 705 of file kprocess.h. Referenced by coreDumped(), exitSignal(), exitStatus(), normalExit(), processHasExited(), signalled(), start(), and wait().

bool KProcess::keepPrivs`[protected]`

| If false, the child process' effective uid & gid will be reset to the real values. See also: setRunPrivileged() Definition at line 713 of file kprocess.h. Referenced by runPrivileged(), and setRunPrivileged().

int KProcess::out[2]`[protected]`

| The socket descriptors for stdout. Definition at line 804 of file kprocess.h. Referenced by closeStdout(), commClose(), commSetupDoneC(), commSetupDoneP(), KProcess(), and setupCommunication().

int KProcess::in[2]`[protected]`

| The socket descriptors for stdin. Definition at line 808 of file kprocess.h. Referenced by closeStdin(), commSetupDoneC(), commSetupDoneP(), KProcess(), setupCommunication(), and slotSendData().

int KProcess::err[2]`[protected]`

| The socket descriptors for stderr. Definition at line 812 of file kprocess.h. Referenced by closeStderr(), commClose(), commSetupDoneC(), commSetupDoneP(), KProcess(), and setupCommunication().

QSocketNotifier* KProcess::innot`[protected]`

| The socket notifier for in[1]. Definition at line 817 of file kprocess.h. Referenced by closeStdin(), commSetupDoneP(), slotSendData(), and writeStdin().

QSocketNotifier* KProcess::outnot`[protected]`

| The socket notifier for out[0]. Definition at line 821 of file kprocess.h. Referenced by closeStdout(), commSetupDoneP(), resume(), and suspend().

QSocketNotifier* KProcess::errnot`[protected]`

| The socket notifier for err[0]. Definition at line 825 of file kprocess.h. Referenced by closeStderr(), and commSetupDoneP().

Communication KProcess::communication`[protected]`

| Lists the communication links that are activated for the child process. Should not be modified from derived classes. Definition at line 831 of file kprocess.h. Referenced by childOutput(), closeStderr(), closeStdin(), closeStdout(), commClose(), commSetupDoneC(), commSetupDoneP(), setupCommunication(), and writeStdin().

const char* KProcess::input_data`[protected]`

| The buffer holding the data that has to be sent to the child. Definition at line 850 of file kprocess.h. Referenced by slotSendData(), start(), and writeStdin().

int KProcess::input_sent`[protected]`

| The number of bytes already transmitted. Definition at line 854 of file kprocess.h. Referenced by slotSendData(), and writeStdin().

int KProcess::input_total`[protected]`

| The total length of input_data. Definition at line 858 of file kprocess.h. Referenced by slotSendData(), and writeStdin().

The documentation for this class was generated from the following files:

- kprocess.h
- kprocess.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:18:56 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003